function Arvore (itens) {
	this.itens = itens;
}

function Politica (nome, sites, permissoes) {
	this.nome = nome;
   this.sites = sites ? sites : null;
	this.permissoes = permissoes ? permissoes : new Array();
}

Arvore.prototype = {
	QueryInterface: function (aIID) {
		if (aIID.equals(Components.interfaces.nsITreeView) ||
		    aIID.equals(Components.interfaces.nsISupports))
			return this;

		throw Components.results.NS_NOINTERFACE;
	},

	getCellText: function (linha, coluna) {
		var texto = null;

		if (coluna.id == "avancado-propriedade")
			texto = this.itens[linha].propriedade;
		else
			switch (this.itens[linha].status) {
				case "noAccess":   texto = CdS.stringset.getString("controledescripts.block");break;
				case "allAccess":  texto = CdS.stringset.getString("controledescripts.allow");break;
				case "sameOrigin": texto = CdS.stringset.getString("controledescripts.sameOrigin");break;
			}

		return texto;
	},

	get rowCount() {return this.itens.length;},
	cycleHeader: function(coluna) {},
	getCellProperties: function(linha, coluna, props) {},
	getColumnProperties: function(colid, coluna, props) {},
	getImageSrc: function(linha, coluna) {return null;},
	getLevel: function(linha) {return 0;},
	getRowProperties: function(linha, props) {},
	isContainer: function(linha) {return false;},
	isSeparator: function(linha) {return false;},
	isSorted: function() {return false;},
	setTree: function(treebox) {this.treebox = treebox;}
}

Politica.prototype = {
	adicionarPermissao: function (permissao) {
		if (permissao) {
			var posicao = this.buscarPermissao(permissao.propriedade);

			if (posicao >= 0)
				this.editarPermissao(posicao, permissao);
			else {
				this.permissoes.push(permissao);
				this.ordenarPermissoes();
			}

			return true;
		}

		return false;
	},

	buscarPermissao: function (propriedade) {
		for (i in this.permissoes)
			if (this.permissoes[i].propriedade == propriedade)
				return parseInt(i);

		return -1;
	},

	editarPermissao: function (indice, permissao) {
		if (permissao && indice >= 0 && indice <= this.permissoes.length) {
			this.permissoes[indice] = permissao;
			this.ordenarPermissoes();
			return true;
		}

		return false;
	},

	ordenarPermissoes: function () {
		var ordenador = function (a, b) {
			if (a.propriedade > b.propriedade)
				return 1;
			else if (a.propriedade < b.propriedade)
				return -1;
			else
				return 0;
		}

		this.permissoes.sort(ordenador);
	},

	removerPermissao: function (indice) {
		this.permissoes.splice(indice, 1);
		return true;
	},

	renomear: function (nomeNovo) {
		if (nomeNovo) {
			this.nome = nomeNovo;
			return true;
		}

		return false;
	}
}
